﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.51
@EndOfDesignText@

Sub Process_Globals
	Private KD As String
	Private KN As String
	Private KI As String
	Private TI As String
	
	Private APIUrl As String
	
	Type GetBitStateReponse (NotSetYet As Boolean, Success As Boolean, ErroMessage As String, ResponseCode As Int, Bit0 As Boolean, Bit1 As Boolean, LastModificationDate As Long)
	Type SetBitStateReponse (Success As Boolean, ErroMessage As String, ResponseCode As Int)
End Sub

Sub Initialize (KeyDir As String, KeyName As String, KeyID As String, TeamID As String, Development As Boolean)
	KD = KeyDir
	KN = KeyName
	KI = KeyID
	TI = TeamID
	
	File.Copy(File.DirAssets,"JWT.jar",File.DirTemp,"JWT.jar")
	
	If Development Then
		APIUrl = "https://api.development.devicecheck.apple.com/"
	Else
		APIUrl = "https://api.devicecheck.apple.com/"
	End If
End Sub

Sub GetBitState (DeviceToken As String) As ResumableSub
	Dim H As HttpJob
	H.Initialize("",Me)
	H.PostString(APIUrl & "v1/query_two_bits",MapToJson(CreateMap("device_token":DeviceToken, "transaction_id":UUID,"timestamp":DateTime.Now)), "Bearer " & CreateJWT.Trim)

	Wait For (J) JobDone(J As HttpJob)
	
	Dim BS As GetBitStateReponse
	
	If J.Success And j.Response.StatusCode = 200 Then
	
		BS.Success = True
		BS.ResponseCode = 200
		
		Dim Resp As String = J.GetString
		
		If Resp.StartsWith("{") Then
			Dim RespMap As Map = JsonToMap(Resp)
			BS.NotSetyet = False
			BS.Bit0 = RespMap.Get("bit0")
			BS.Bit1 = RespMap.Get("bit1")
			DateTime.DateFormat = "YYYY-MM"
			BS.LastModificationDate = DateTime.DateParse(RespMap.Get("last_update_time"))
		Else
			BS.NotSetyet = True
			BS.Bit0 = False
			BS.Bit1 = False
			BS.LastModificationDate = 0
		End If
		
		Return BS
	Else
		BS.Success = False
		BS.NotSetyet = False
		BS.Bit0 = False
		BS.Bit1 = False
		BS.LastModificationDate = 0
		BS.ErroMessage = J.ErrorMessage
		BS.ResponseCode = J.Response.StatusCode
		Return BS
	End If
End Sub

Sub SetBitState (DeviceToken As String, Bit0 As Boolean, Bit1 As Boolean) As ResumableSub
	Dim H As HttpJob
	H.Initialize("",Me)
	H.PostString(APIUrl & "v1/update_two_bits",MapToJson(CreateMap("device_token":DeviceToken, "transaction_id":UUID,"timestamp":DateTime.Now,"bit0":Bit0,"bit1":Bit1)), "Bearer " & CreateJWT.Trim)
	
	Dim BS As SetBitStateReponse
	
	Wait For (J) JobDone(J As HttpJob)
	
	If J.Success And j.Response.StatusCode = 200 Then
		Dim Resp As String = J.GetString
		
		BS.ResponseCode = 200
		BS.Success = (Resp = "")
		
		Return BS
	Else
		BS.Success = False
		BS.ResponseCode = J.Response.StatusCode
		BS.ErroMessage = J.ErrorMessage
		Return BS
	End If
End Sub

Private Sub CreateJWT As String
	Dim S As Shell
	S.Initialize("","java",Array("-jar",File.Combine(File.Dirtemp,"JWT.jar"),File.Combine(KD,KN),KI,TI))
	Dim SSR As ShellSyncResult = S.RunSynchronous(10000)
	If SSR.Success Then
		Return SSR.StdOut
	Else
		LogError("Unable to create JWT")
		Return ""
	End If
End Sub

Private Sub JsonToMap (J As String) As Map
	Dim P As JSONParser
	P.Initialize(J)
	Return P.NextObject
End Sub

Private Sub MapToJson (M As Map) As String
	Dim J As JSONGenerator
	J.Initialize(M)
	Return J.ToString
End Sub

Private Sub UUID As String
	Dim jo As JavaObject
	Return jo.InitializeStatic("java.util.UUID").RunMethod("randomUUID", Null)
End Sub